part of '../../../account_management.dart';

class AccountModel extends NameModel<int> {
  static const String descriptionTag = "description";
  final String? description;
  static const String branchIdTag = "branchId";
  final int branchId;
  static const String typeIdTag = "typeId";
  final int typeId;
  static const String levelIdTag = "levelId";
  final int levelId;
  static const String upIdTag = "upId";
  final int? upId;
  static const String groupIdTag = "groupId";
  final int? groupId;

  static const String sessionIdTag = "sessionId";
  final int sessionId;
  static const String userIdTag = "userId";
  final int userId;

  /// primary key
  @override
  List<Object?> get props => [...super.props, branchId];

  const AccountModel({
    super.id = 0,
    required super.name,
    super.status,
    this.description,
    required this.branchId,
    required this.typeId,
    required this.levelId,
    this.upId,
    this.groupId,
  })  : sessionId = 0,
        userId = 0;
  AccountModel.fromMap(super.map)
      : description = map.getString(descriptionTag),
        branchId = map.getInt(branchIdTag)!,
        typeId = map.getInt(typeIdTag)!,
        levelId = map.getInt(levelIdTag)!,
        upId = map.getInt(upIdTag),
        groupId = map.getInt(groupIdTag),
        sessionId = map.getInt(sessionIdTag)!,
        userId = map.getInt(userIdTag)!,
        super.fromMap();

  @override
  Map<String, dynamic> toMap() => {
        ...super.toMap(),
        descriptionTag: description,
        branchIdTag: branchId,
        typeIdTag: typeId,
        levelIdTag: levelId,
        upIdTag: upId,
        groupIdTag: groupId,
      };
}

extension AccountModelExtension<ModelType extends AccountModel>
    on Iterable<ModelType> {
  ModelType? firstWhereByUpUnit(int? upId) =>
      firstWhereOrNull((element) => element.upId == upId);
  ModelType? lastWhereByUpUnit(int? upId) =>
      lastWhereOrNull((element) => element.upId == upId);

  Iterable<ModelType> whereByUpUnit(int? upId) =>
      where((element) => element.upId == upId);
}
