part of '../../../account_management.dart';

class AccountCurrencyModel extends Model {
  final int branchId;
  static const String branchIdTag = "branchId";
  final int accountId;
  static const String accountIdTag = "accountId";
  final int currencyId;
  static const String currencyIdTag = "currencyId";
  final double price;
  static const String priceTag = "price";
  final bool status;
  static const String statusTag = "status";

  final DateTime createAt;
  static const String createAtTag = "createAt";

  /// primary key
  @override
  List<Object?> get props => [branchId, accountId, currencyId];

  final int sessionId;
  static const String sessionIdTag = "sessionId";
  final int userId;
  static const String userIdTag = "userId";

  AccountCurrencyModel({
    this.branchId = 0,
    required this.accountId,
    required this.currencyId,
    required this.price,
    this.status = true,
  })  : createAt = DateTime.now(),
        sessionId = 0,
        userId = 0;

  AccountCurrencyModel.fromMap(super.map)
      : branchId = map.getInt(branchIdTag)!,
        accountId = map.getInt(accountIdTag)!,
        currencyId = map.getInt(currencyIdTag)!,
        price = map.getDouble(priceTag)!,
        status = map.getBool(statusTag)!,
        createAt = map.getDateTime(createAtTag)!,
        sessionId = map.getInt(sessionIdTag)!,
        userId = map.getInt(userIdTag)!,
        super.fromMap();

  @override
  Map<String, dynamic> toMap() => {
        branchIdTag: branchId,
        accountIdTag: accountId,
        currencyIdTag: currencyId,
        priceTag: price,
        statusTag: status,
        createAtTag: createAt,
      };
}

extension AccountCurrencyModelExtension<ModelType extends AccountCurrencyModel>
    on Iterable<ModelType> {}
