part of '../../../account_management.dart';

class AccountGroupModel extends NameModel<int> {
  static const String descriptionTag = "description";
  final String? description;
  static const String upIdTag = "upId";
  final int? upId;
  static const String sessionIdTag = "sessionId";
  final int sessionId;
  static const String userIdTag = "userId";
  final int userId;

  const AccountGroupModel({
    super.id = 0,
    required super.name,
    super.status,
    this.description,
    this.upId,
  })  : sessionId = 0,
        userId = 0;
  AccountGroupModel.fromMap(super.map)
      : description = map.getString(descriptionTag),
        upId = map.getInt(upIdTag),
        sessionId = map.getInt(sessionIdTag)!,
        userId = map.getInt(userIdTag)!,
        super.fromMap();

  @override
  Map<String, dynamic> toMap() => {
        ...super.toMap(),
        descriptionTag: description,
        upIdTag: upId,
      };
}

extension AccountGroupModelExtension<ModelType extends AccountGroupModel>
    on Iterable<ModelType> {
  ModelType? firstWhereByUpUnit(int? upId) =>
      firstWhereOrNull((element) => element.upId == upId);
  ModelType? lastWhereByUpUnit(int? upId) =>
      lastWhereOrNull((element) => element.upId == upId);

  Iterable<ModelType> whereByUpUnit(int? upId) =>
      where((element) => element.upId == upId);
}
