part of '../../../account_management.dart';

class AccountLevelModel extends NameModel<int> {
  static const String descriptionTag = "description";
  final String? description;
  static const String upIdTag = "upId";
  final int? upId;

  const AccountLevelModel({
    super.id = 0,
    required super.name,
    super.status,
    this.description,
    this.upId,
  });
  AccountLevelModel.fromMap(super.map)
      : description = map.getString(descriptionTag),
        upId = map.getInt(upIdTag),
        super.fromMap();

  @override
  Map<String, dynamic> toMap() => {
        ...super.toMap(),
        descriptionTag: description,
        upIdTag: upId,
      };
}

extension AccountLevelModelExtension<ModelType extends AccountLevelModel>
    on Iterable<ModelType> {
  ModelType? firstWhereByUpUnit(int? upId) =>
      firstWhereOrNull((element) => element.upId == upId);
  ModelType? lastWhereByUpUnit(int? upId) =>
      lastWhereOrNull((element) => element.upId == upId);

  Iterable<ModelType> whereByUpUnit(int? upId) =>
      where((element) => element.upId == upId);
}
