part of '../../../account_management.dart';

class AccountTypeModel extends NameModel<int> {
  static const String descriptionTag = "description";
  final String? description;

  const AccountTypeModel({
    super.id = 0,
    required super.name,
    super.status,
    this.description,
  });
  AccountTypeModel.fromMap(super.map)
      : description = map.getString(descriptionTag),
        super.fromMap();

  @override
  Map<String, dynamic> toMap() => {
        ...super.toMap(),
        descriptionTag: description,
      };
}

extension AccountTypeModelExtension<ModelType extends AccountTypeModel>
    on Iterable<ModelType> {}
