part of '../../../account_management.dart';

class ReceiptDetailModel extends Model {
  final int branchId;
  static const String branchIdTag = "branchId";
  final int typeId;
  static const String typeIdTag = "typeId";
  final int receiptId;
  static const String receiptIdTag = "receiptId";
  final int accountId;
  static const String accountIdTag = "accountId";
  final int currencyId;
  static const String currencyIdTag = "currencyId";
  final double price;
  static const String priceTag = "price";

  final String? description;
  static const String descriptionTag = "description";

  /// primary key
  @override
  List<Object?> get props =>
      [branchId, typeId, receiptId, accountId, currencyId];

  final int sessionId;
  static const String sessionIdTag = "sessionId";
  final int userId;
  static const String userIdTag = "userId";

  const ReceiptDetailModel({
    this.branchId = 0,
    this.typeId = 0,
    this.receiptId = 0,
    required this.accountId,
    required this.currencyId,
    required this.price,
    this.description,
  })  : sessionId = 0,
        userId = 0;

  ReceiptDetailModel.fromMap(super.map)
      : branchId = map.getInt(branchIdTag)!,
        typeId = map.getInt(typeIdTag)!,
        receiptId = map.getInt(receiptIdTag)!,
        accountId = map.getInt(accountIdTag)!,
        currencyId = map.getInt(currencyIdTag)!,
        price = map.getDouble(priceTag)!,
        sessionId = map.getInt(sessionIdTag)!,
        userId = map.getInt(userIdTag)!,
        description = map.getString(descriptionTag),
        super.fromMap();

  @override
  Map<String, dynamic> toMap() => {
        branchIdTag: branchId,
        typeIdTag: typeId,
        receiptIdTag: receiptId,
        accountIdTag: accountId,
        currencyIdTag: currencyId,
        priceTag: price,
        descriptionTag: description,
      };
}

extension ReceiptDetailModelExtension<ModelType extends ReceiptDetailModel>
    on Iterable<ModelType> {}
