part of '../../../permission_management.dart';

class BranchUserPermissionModel extends Model {
  final int branchId;
  static const String branchIdTag = "branchId";
  final int userId;
  static const String userIdTag = "userId";
  final int permissionId;
  static const String permissionIdTag = "permissionId";
  final bool status;
  static const String statusTag = "status";
  final bool permissionStatus;
  static const String permissionStatusTag = "permissionStatus";

  /// primary key
  @override
  List<Object?> get props => [branchId, userId, permissionId];

  const BranchUserPermissionModel({
    required this.branchId,
    required this.userId,
    required this.permissionId,
    required this.status,
    required this.permissionStatus,
  });

  BranchUserPermissionModel.fromMap(super.map)
      : branchId = map.getInt(branchIdTag)!,
        userId = map.getInt(userIdTag)!,
        permissionId = map.getInt(permissionIdTag)!,
        status = map.getBool(statusTag)!,
        permissionStatus = map.getBool(permissionStatusTag)!,
        super.fromMap();

  @override
  Map<String, dynamic> toMap() => {
        branchIdTag: branchId,
        userIdTag: userId,
        permissionIdTag: permissionId,
        statusTag: status,
        permissionStatusTag: permissionStatus,
      };
}

extension BranchUserPermissionModelExtension<
    ModelType extends BranchUserPermissionModel> on Iterable<ModelType> {}
