part of '../../../permission_management.dart';

class PermissionModel extends NameModel<int> {
  final int typeId;
  static const String typeIdTag = "typeId";
  final int? upId;
  static const String upIdTag = "upId";
  final bool upStatus;
  static const String upStatusTag = "upStatus";
  final String? description;
  static const String descriptionTag = "description";

  const PermissionModel({
    super.id = 0,
    required super.name,
    super.status,
    required this.typeId,
    this.upId,
    this.description,
  }) : upStatus = true;

  PermissionModel.fromMap(super.map)
      : typeId = map.getInt(typeIdTag)!,
        upId = map.getInt(upIdTag),
        upStatus = map.getBool(upStatusTag)!,
        description = map.getString(descriptionTag),
        super.fromMap();

  @override
  Map<String, dynamic> toMap() => {
        ...super.toMap(),
        descriptionTag: description,
      };
}

extension PermissionModelExtension<ModelType extends PermissionModel>
    on Iterable<ModelType> {}
