part of '../../../permission_management.dart';

class SessionModel extends StatusModel<int> {
  final String deviceId;
  static const String deviceIdTag = "deviceId";
  final String userId;
  static const String userIdTag = "userId";
  final DateTime startAt;
  static const String startAtTag = "startAt";
  final DateTime lastUseAt;
  static const String lastUseAtTag = "lastUseAt";

  SessionModel({
    super.id = 0,
    super.status,
    this.deviceId = "",
    this.userId = "",
  })  : startAt = DateTime.now(),
        lastUseAt = DateTime.now();

  SessionModel.fromMap(super.map)
      : deviceId = map.getString(deviceIdTag)!,
        userId = map.getString(userIdTag)!,
        startAt = map.getDateTime(startAtTag)!,
        lastUseAt = map.getDateTime(lastUseAtTag)!,
        super.fromMap();

  @override
  Map<String, dynamic> toMap() => {
        ...super.toMap(),
        deviceIdTag: deviceId,
        userIdTag: userId,
      };
}

extension SessionModelExtension<ModelType extends SessionModel>
    on Iterable<ModelType> {}
