part of '../../../permission_management.dart';

class UserModel extends IdentityModel<int> {
  static const String nameTag = "name";
  final String name;

  const UserModel({
    super.id = 0,
    required this.name,
  });
  UserModel.fromMap(super.map)
      : name = map.getString(nameTag)!,
        super.fromMap();

  @override
  Map<String, dynamic> toMap() => {
        ...super.toMap(),
        nameTag: name,
      };
}

extension UserModelExtension<ModelType extends UserModel>
    on Iterable<ModelType> {}
