part of '../../../permission_management.dart';

class UserRoleModel extends NameModel<int> {
  static const String descriptionTag = "description";
  final String? description;

  const UserRoleModel({
    super.id = 0,
    required super.name,
    super.status,
    this.description,
  });
  UserRoleModel.fromMap(super.map)
      : description = map.getString(descriptionTag),
        super.fromMap();

  @override
  Map<String, dynamic> toMap() => {
        ...super.toMap(),
        descriptionTag: description,
      };
}

extension UserRoleModelExtension<ModelType extends UserRoleModel>
    on Iterable<ModelType> {}
