part of '../../../public.dart';

abstract class IdentityFilter<IdType, ModelType extends IdentityModel<IdType>>
    extends TableFilter<ModelType> {
  final InWhere<IdType>? ids;

  const IdentityFilter({this.ids});
  @override
  Map<String, dynamic> toMap() => {"ids": ids?.toMap()};

  @override
  bool check(ModelType element) =>
      super.check(element) && (ids?.check(element.id) ?? true);

  IdentityFilter copyWith({InWhere<IdType>? ids});
}
