part of '../../../public.dart';

abstract class NameFilter<IdType, ModelType extends NameModel<IdType>>
    extends StatusFilter<IdType, ModelType> {
  final LikeWhere? text;

  const NameFilter({
    super.ids,
    super.status,
    this.text,
  });

  bool textCheck(ModelType element) => text?.check(element.name) ?? true;

  @override
  Map<String, dynamic> toMap() => {...super.toMap(), "text": text?.toMap()};

  @override
  bool check(ModelType element) => super.check(element) && textCheck(element);

  @override
  NameFilter copyWith(
      {InWhere<IdType>? ids, InWhere<bool>? status, LikeWhere? text});
}
