part of '../../../public.dart';

abstract class StatusFilter<IdType, ModelType extends StatusModel<IdType>>
    extends IdentityFilter<IdType, ModelType> {
  final InWhere<bool>? status;

  const StatusFilter({
    super.ids,
    this.status,
  });

  @override
  Map<String, dynamic> toMap() => {...super.toMap(), "status": status?.toMap()};

  @override
  bool check(ModelType element) =>
      super.check(element) && (status?.check(element.status) ?? true);

  @override
  StatusFilter copyWith({InWhere<IdType>? ids, InWhere<bool>? status});
}
