part of '../../public.dart';

abstract class NameModel<IdType> extends StatusModel<IdType> {
  static const String nameTag = "name";
  final String name;

  const NameModel({required super.id, super.status, required this.name});
  NameModel.fromMap(super.map)
      : name = map.getString(nameTag)!,
        super.fromMap();

  @override
  Map<String, dynamic> toMap() => {...super.toMap(), nameTag: name};
}

extension NameModelExtension<IdType, ModelType extends NameModel<IdType>>
    on Iterable<ModelType> {
  ModelType? firstWhereByName(String? name) =>
      firstWhereOrNull((element) => element.name == name);
  ModelType? lastWhereByName(String? name) =>
      lastWhereOrNull((element) => element.name == name);
  Iterable<ModelType> whereByName(String? name) =>
      where((element) => element.name == name);
}
