part of '../../../store_management.dart';

class ProductMeasureModel extends Model {
  static const String productIdTag = "productId";
  final int productId;
  static const String measureUnitIdTag = "measureUnitId";
  final int measureUnitId;
  static const String currencyIdTag = "currencyId";
  final int currencyId;
  static const String priceTag = "price";
  final double price;
  static const String statusTag = "status";
  final bool status;
  static const String barcodeTag = "barcode";
  final String? barcode;
  static const String minCountTag = "minCount";
  final int minCount;
  static const String maxCountTag = "maxCount";
  final int? maxCount;
  static const String notifyCountTag = "notifyCount";
  final int? notifyCount;
  static const String sessionIdTag = "sessionId";
  final int sessionId;

  const ProductMeasureModel({
    required this.productId,
    required this.measureUnitId,
    required this.currencyId,
    required this.price,
    this.status = true,
    this.barcode,
    this.minCount = 1,
    this.maxCount,
    this.notifyCount,
    this.sessionId = 0,
  });

  ProductMeasureModel.fromMap(super.map)
      : productId = map.getInt(productIdTag)!,
        measureUnitId = map.getInt(measureUnitIdTag)!,
        currencyId = map.getInt(currencyIdTag)!,
        price = map.getDouble(priceTag)!,
        status = map.getBool(statusTag)!,
        barcode = map.getString(barcodeTag),
        minCount = map.getInt(minCountTag)!,
        maxCount = map.getInt(maxCountTag),
        notifyCount = map.getInt(notifyCountTag),
        sessionId = map.getInt(sessionIdTag)!,
        super.fromMap();

  @override
  List<Object?> get props => [productId, measureUnitId, currencyId];

  @override
  Map<String, dynamic> toMap() => {
        productIdTag: productId,
        measureUnitIdTag: measureUnitId,
        currencyIdTag: currencyId,
        priceTag: price,
        statusTag: status,
        barcodeTag: barcode,
      };
}
