part of '../../../store_management.dart';

class ProductStorageModel extends Model {
  static const String branchIdTag = "branchId";
  final int branchId;
  static const String productIdTag = "productId";
  final int productId;
  static const String measureUnitIdTag = "measureUnitId";
  final int measureUnitId;
  static const String currencyIdTag = "currencyId";
  final int currencyId;
  static const String storeIdTag = "storeId";
  final int storeId;
  static const String priceTag = "price";
  final double price;
  static const String expiredAtTag = "expiredAt";
  final DateTime expiredAt;
  static const String countTag = "count";
  final int count;

  ProductStorageModel.fromMap(super.map)
      : branchId = map.getInt(branchIdTag)!,
        productId = map.getInt(productIdTag)!,
        measureUnitId = map.getInt(measureUnitIdTag)!,
        currencyId = map.getInt(currencyIdTag)!,
        storeId = map.getInt(storeIdTag)!,
        price = map.getDouble(priceTag)!,
        count = map.getInt(countTag)!,
        expiredAt = map.getDateTime(expiredAtTag)!,
        super.fromMap();

  @override
  List<Object?> get props => [
        branchId,
        productId,
        measureUnitId,
        currencyId,
        storeId,
        price,
        expiredAt
      ];

  @override
  Map<String, dynamic> toMap() => {
        branchIdTag: branchId,
        productIdTag: productId,
        measureUnitIdTag: measureUnitId,
        currencyIdTag: currencyId,
        storeIdTag: storeId,
        priceTag: price,
        countTag: count,
        expiredAtTag: expiredAt.toIso8601String(),
      };
}
